HealBot_ConfigDefaults = {
  Version = HEALBOT_VERSION,
  HealBot_Profile = 1;
  HealthPctPvP = 0.99,
  HealthPctPvE = 0.92,
  AlertLevelPvP = 0.75,
  AlertLevelPvE = 0.84,
  AutoShowPvP = 1,
  AutoShowPvE = 1,
  PanelSoundsPvP = 1,
  PanelSoundsPvE = 1,
  TargetWhisperPvP = 1,
  TargetWhisperPvE = 1,
  GroupHealsPvP = 0,
  GroupHealsPvE = 1,
  TankHealsPvP = 0,
  TankHealsPvE = 1,
  TargetHealsPvP = 1,
  TargetHealsPvE = 1,
  EmergencyHealsPvP = 1,
  EmergencyHealsPvE = 1,
  EmergRangePvP = 1,
  EmergRangePvE = 1,
  ActionAlphaPvP = 0.05,
  ActionAlphaPvE = 0.05,
  BarAlphaPvP    = 0.42,
  BarAlphaPvE    = 0.42,
  AlertSecondsPvP = 15,
  AlertSecondsPvE = 15,
  ActionLockedPvP = 0,
  ActionLockedPvE = 0,
  HealingUsagePvP = 15,
  HealingUsagePvE = 7,
  OverHealPvP = 0.99,
  OverHealPvE = 0.25,
  ManaReservePvP  = 0.01,
  ManaReservePvE  = 0.1,
  UseHealingPvP = {
    [HEALBOT_FLASH_HEAL]          = 1,
    [HEALBOT_FLASH_OF_LIGHT]      = 1,
    [HEALBOT_GREATER_HEAL]        = 1,
    [HEALBOT_HEALING_TOUCH]       = 1,
    [HEALBOT_HEAL]                = 1,
    [HEALBOT_HEALING_WAVE]        = 1,
    [HEALBOT_HOLY_LIGHT]          = 1,
    [HEALBOT_LESSER_HEAL]         = 1,
    [HEALBOT_LESSER_HEALING_WAVE] = 1,
    [HEALBOT_MEND_PET]            = 1,
    [HEALBOT_POWER_WORD_SHIELD]   = 0,
    [HEALBOT_REGROWTH]            = 1,
    [HEALBOT_RENEW]               = 1,
    [HEALBOT_REJUVENATION]        = 1,
    [HEALBOT_BANDAGES]            = 1,
    [HEALBOT_HEALING_POTIONS]     = 1,
    [HEALBOT_HEALTHSTONES]        = 1,
  },
  UseHealingPvE = {
    [HEALBOT_FLASH_HEAL]          = 1,
    [HEALBOT_FLASH_OF_LIGHT]      = 1,
    [HEALBOT_GREATER_HEAL]        = 1,
    [HEALBOT_HEALING_TOUCH]       = 1,
    [HEALBOT_HEAL]                = 1,
    [HEALBOT_HEALING_WAVE]        = 1,
    [HEALBOT_HOLY_LIGHT]          = 1,
    [HEALBOT_LESSER_HEAL]         = 1,
    [HEALBOT_LESSER_HEALING_WAVE] = 1,
    [HEALBOT_MEND_PET]            = 1,
    [HEALBOT_POWER_WORD_SHIELD]   = 0,
    [HEALBOT_REGROWTH]            = 1,
    [HEALBOT_RENEW]               = 1,
    [HEALBOT_REJUVENATION]        = 1,
    [HEALBOT_BANDAGES]            = 1,
    [HEALBOT_HEALING_POTIONS]     = 1,
    [HEALBOT_HEALTHSTONES]        = 1,
  },
  CastNotifyPvP = 1,
  CastNotifyPvE = 1,
  HideOptionsPvP = 0,
  HideOptionsPvE = 0,
  ShowTooltipPvP = 1,
  ShowTooltipPvE = 1,
  GrowUpwardsPvP = 0,
  GrowUpwardsPvE = 0,
  IntegrateCTRAPvP = 0,
  IntegrateCTRAPvE = 1,
  ProtectPvPPvP = 0,
  ProtectPvPPvE = 1,
  EmergencyLevelPvP = 0.8,
  EmergencyLevelPvE = 0.45,
  QualityRangePvP = 0,
  QualityRangePvE = 0,
  EmergencySortPvP = 1,
  EmergencySortPvE = 1,
  ToggleAltUsePvP = 0,
  ToggleAltUsePvE = 0,
  EmergIncMonitorPvP = 1,
  EmergIncMonitorPvE = 1,
  EmergencyFClassPvE = 4,
  EmergencyFClassPvP = 4,
  EmergIncRangePvP = {
    [HEALBOT_DRUID]    = 0,
    [HEALBOT_HUNTER]   = 1,
    [HEALBOT_MAGE]     = 1,
    [HEALBOT_PALADIN]  = 0,
    [HEALBOT_PRIEST]   = 0,
    [HEALBOT_ROGUE]    = 0,
    [HEALBOT_SHAMAN]   = 0,
    [HEALBOT_WARLOCK]  = 1,
    [HEALBOT_WARRIOR]  = 0,
  },
  EmergIncRangePvE = {
    [HEALBOT_DRUID]    = 0,
    [HEALBOT_HUNTER]   = 1,
    [HEALBOT_MAGE]     = 1,
    [HEALBOT_PALADIN]  = 0,
    [HEALBOT_PRIEST]   = 0,
    [HEALBOT_ROGUE]    = 0,
    [HEALBOT_SHAMAN]   = 0,
    [HEALBOT_WARLOCK]  = 1,
    [HEALBOT_WARRIOR]  = 0,
  },
  EmergIncMeleePvP = {
    [HEALBOT_DRUID]    = 0,
    [HEALBOT_HUNTER]   = 0,
    [HEALBOT_MAGE]     = 0,
    [HEALBOT_PALADIN]  = 0,
    [HEALBOT_PRIEST]   = 0,
    [HEALBOT_ROGUE]    = 1,
    [HEALBOT_SHAMAN]   = 0,
    [HEALBOT_WARLOCK]  = 0,
    [HEALBOT_WARRIOR]  = 1,
  },
  EmergIncMeleePvE = {
    [HEALBOT_DRUID]    = 0,
    [HEALBOT_HUNTER]   = 0,
    [HEALBOT_MAGE]     = 0,
    [HEALBOT_PALADIN]  = 0,
    [HEALBOT_PRIEST]   = 0,
    [HEALBOT_ROGUE]    = 1,
    [HEALBOT_SHAMAN]   = 0,
    [HEALBOT_WARLOCK]  = 0,
    [HEALBOT_WARRIOR]  = 1,
  },
  EmergIncHealersPvP = {
    [HEALBOT_DRUID]    = 1,
    [HEALBOT_HUNTER]   = 0,
    [HEALBOT_MAGE]     = 0,
    [HEALBOT_PALADIN]  = 0,
    [HEALBOT_PRIEST]   = 1,
    [HEALBOT_ROGUE]    = 0,
    [HEALBOT_SHAMAN]   = 0,
    [HEALBOT_WARLOCK]  = 0,
    [HEALBOT_WARRIOR]  = 0,
  },
  EmergIncHealersPvE = {
    [HEALBOT_DRUID]    = 1,
    [HEALBOT_HUNTER]   = 0,
    [HEALBOT_MAGE]     = 0,
    [HEALBOT_PALADIN]  = 0,
    [HEALBOT_PRIEST]   = 1,
    [HEALBOT_ROGUE]    = 0,
    [HEALBOT_SHAMAN]   = 0,
    [HEALBOT_WARLOCK]  = 0,
    [HEALBOT_WARRIOR]  = 0,
  },
  EmergIncCustomPvP = {
    [HEALBOT_DRUID]    = 1,
    [HEALBOT_HUNTER]   = 0,
    [HEALBOT_MAGE]     = 1,
    [HEALBOT_PALADIN]  = 1,
    [HEALBOT_PRIEST]   = 1,
    [HEALBOT_ROGUE]    = 0,
    [HEALBOT_SHAMAN]   = 1,
    [HEALBOT_WARLOCK]  = 1,
    [HEALBOT_WARRIOR]  = 0,
  },
  EmergIncCustomPvE = {
    [HEALBOT_DRUID]    = 1,
    [HEALBOT_HUNTER]   = 0,
    [HEALBOT_MAGE]     = 1,
    [HEALBOT_PALADIN]  = 1,
    [HEALBOT_PRIEST]   = 1,
    [HEALBOT_ROGUE]    = 0,
    [HEALBOT_SHAMAN]   = 1,
    [HEALBOT_WARLOCK]  = 1,
    [HEALBOT_WARRIOR]  = 0,
  },
  KeyComboPvP = {
    [HEALBOT_DRUID] = {
      ["ShiftLeft"] = HEALBOT_REJUVENATION,
      ["CtrlLeft"] = HEALBOT_REGROWTH,
    },
    [HEALBOT_HUNTER] = {
    },
    [HEALBOT_PALADIN] = {
      ["ShiftLeft"] = HEALBOT_FLASH_OF_LIGHT,
      ["CtrlLeft"] = HEALBOT_HOLY_LIGHT,
    },
    [HEALBOT_PRIEST] = {
      ["ShiftLeft"] = HEALBOT_FLASH_HEAL,
      ["CtrlLeft"] = HEALBOT_POWER_WORD_SHIELD,
    },
    [HEALBOT_SHAMAN] = {
      ["ShiftLeft"] = HEALBOT_LESSER_HEALING_WAVE,
    },
  },
  KeyComboPvE = {
    [HEALBOT_DRUID] = {
      ["ShiftLeft"] = HEALBOT_REJUVENATION,
      ["CtrlLeft"] = HEALBOT_REGROWTH,
    },
    [HEALBOT_HUNTER] = {
    },
    [HEALBOT_PALADIN] = {
      ["ShiftLeft"] = HEALBOT_FLASH_OF_LIGHT,
      ["CtrlLeft"] = HEALBOT_HOLY_LIGHT,
    },
    [HEALBOT_PRIEST] = {
      ["ShiftLeft"] = HEALBOT_FLASH_HEAL,
      ["CtrlLeft"] = HEALBOT_POWER_WORD_SHIELD,
    },
    [HEALBOT_SHAMAN] = {
      ["ShiftLeft"] = HEALBOT_LESSER_HEALING_WAVE,
    },
  },
  EnableHealthyPvP = 0,
  EnableHealthyPvE = 0,
  ActionVisiblePvP = 0,
  ActionVisiblePvE = 0,
};

HealBot_Config = {};

HealBot_EmergIncMelee = {};
HealBot_EmergIncRange = {};
HealBot_EmergIncHealers = {};
HealBot_EmergIncCustom = {};
HealBot_UseHealing = {};
HealBot_KeyCombo = {};
HealBot_HealsIn = {};
HealBot_Healers = {};

HealBot_ResetHealsInFlag=true;

HEALBOT_ADDON_ID="HealBot_Heals"

HealBot_AbortButton=1;

HealBot_Groups = {
  ["ITEMS"] = {
    HEALBOT_BANDAGES,
    HEALBOT_HEALING_POTIONS,
    HEALBOT_HEALTHSTONES,
  },
  ["PALADIN"] = {
    HEALBOT_HOLY_LIGHT,
    HEALBOT_FLASH_OF_LIGHT,
  },
}

HealBot_Spells = {
-- Cast     = secs until effect starts
-- Channel  = secs until caster available
-- Duration = secs until effect ends
-- Shield   = maximum duration

  [HEALBOT_LINEN_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 6.0, 
    Mana =  0, HealsExt =   66, Price =   40, Level =  1,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_HEAVY_LINEN_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 6.0, 
    Mana =  0, HealsExt =  114, Price =   80, Level =  1,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_WOOL_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 7.0, 
    Mana =  0, HealsExt =  161, Price =   150, Level =  1,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_HEAVY_WOOL_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 7.0, 
    Mana =  0, HealsExt =  301, Price =   275, Level =  1,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_SILK_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 8.0, 
    Mana =  0, HealsExt =  400, Price =  375, Level =  1,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_HEAVY_SILK_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 8.0, 
    Mana =  0, HealsExt =  640, Price =  600, Level =  1,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_MAGEWEAVE_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 8.0, 
    Mana =  0, HealsExt =  800, Price =  750, Level =  1,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_HEAVY_MAGEWEAVE_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 8.0, 
    Mana =  0, HealsExt = 1104, Price =  1050, Level =  1,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_RUNECLOTH_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 8.0, 
    Mana =  0, HealsExt = 1360, Price =  1300, Level = 52,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },
  [HEALBOT_HEAVY_RUNECLOTH_BANDAGE] = {
    Group = HEALBOT_BANDAGES, Range = 15, Channel = 8.0, 
    Mana =  0, HealsExt = 2000, Price = 1800, Level = 58,
    Buff = HEALBOT_BUFF_FIRST_AID, Debuff = HEALBOT_DEBUFF_RECENTLY_BANDAGED },

  [HEALBOT_MINOR_HEALING_POTION] = {
    Group = HEALBOT_HEALING_POTIONS, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =   70, HealsMax =   90, Price =   100, Level =  5 },
  [HEALBOT_LESSER_HEALING_POTION] = {
    Group = HEALBOT_HEALING_POTIONS, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =  140, HealsMax =  180, Price =  200, Level = 13 },
  [HEALBOT_HEALING_POTION] = {
    Group = HEALBOT_HEALING_POTIONS, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =  280, HealsMax =  360, Price =  375, Level = 22 },
  [HEALBOT_GREATER_HEALING_POTION] = {
    Group = HEALBOT_HEALING_POTIONS, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =  455, HealsMax =  585, Price =  625, Level = 31 },
  [HEALBOT_SUPERIOR_HEALING_POTION] = {
    Group = HEALBOT_HEALING_POTIONS, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =  700, HealsMax =  900, Price = 1150, Level = 45 },
  [HEALBOT_MAJOR_HEALING_POTION] = {
    Group = HEALBOT_HEALING_POTIONS, Range = 15, Target = {"player"},
    Mana =  0, HealsMin = 1050, HealsMax = 1750, Price = 2000, Level = 55 },

  [HEALBOT_MINOR_HEALTHSTONE] = {
    Group = HEALBOT_HEALTHSTONES, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =  110, HealsMax =  110, Price = 50, Level = 10 },
  [HEALBOT_LESSER_HEALTHSTONE] = {
    Group = HEALBOT_HEALTHSTONES, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =  275, HealsMax =  275, Price = 125, Level = 22 },
  [HEALBOT_HEALTHSTONE] = {
    Group = HEALBOT_HEALTHSTONES, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =  500, HealsMax =  500, Price = 225, Level = 34 },
  [HEALBOT_GREATER_HEALTHSTONE] = {
    Group = HEALBOT_HEALTHSTONES, Range = 1, Target = {"player"},
    Mana =  0, HealsMin =  880, HealsMax =  880, Price = 400, Level = 46 },
  [HEALBOT_MAJOR_HEALTHSTONE] = {
    Group = HEALBOT_HEALTHSTONES, Range = 1, Target = {"player"},
    Mana =  0, HealsMin = 1440, HealsMax = 1440, Price = 650, Level = 58 },
 
-- PALADIN

  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_1] = { Group = HEALBOT_HOLY_LIGHT, Level =  1 },
  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_2] = { Group = HEALBOT_HOLY_LIGHT, Level =  6 },
  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_3] = { Group = HEALBOT_HOLY_LIGHT, Level = 14 },
  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_4] = { Group = HEALBOT_HOLY_LIGHT, Level = 22 },
  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_5] = { Group = HEALBOT_HOLY_LIGHT, Level = 30 },
  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_6] = { Group = HEALBOT_HOLY_LIGHT, Level = 38 },
  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_7] = { Group = HEALBOT_HOLY_LIGHT, Level = 46 },
  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_8] = { Group = HEALBOT_HOLY_LIGHT, Level = 54 },
  [HEALBOT_HOLY_LIGHT .. HEALBOT_RANK_9] = { Group = HEALBOT_HOLY_LIGHT, Level = 60 },

  [HEALBOT_FLASH_OF_LIGHT .. HEALBOT_RANK_1] = { Group = HEALBOT_FLASH_OF_LIGHT, Level = 20 },
  [HEALBOT_FLASH_OF_LIGHT .. HEALBOT_RANK_2] = { Group = HEALBOT_FLASH_OF_LIGHT, Level = 26 },
  [HEALBOT_FLASH_OF_LIGHT .. HEALBOT_RANK_3] = { Group = HEALBOT_FLASH_OF_LIGHT, Level = 34 },
  [HEALBOT_FLASH_OF_LIGHT .. HEALBOT_RANK_4] = { Group = HEALBOT_FLASH_OF_LIGHT, Level = 42 },
  [HEALBOT_FLASH_OF_LIGHT .. HEALBOT_RANK_5] = { Group = HEALBOT_FLASH_OF_LIGHT, Level = 50 },
  [HEALBOT_FLASH_OF_LIGHT .. HEALBOT_RANK_6] = { Group = HEALBOT_FLASH_OF_LIGHT, Level = 58 },

-- DRUID

  [HEALBOT_REJUVENATION .. HEALBOT_RANK_1 ] = { Group = HEALBOT_REJUVENATION, Level =  4, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_2 ] = { Group = HEALBOT_REJUVENATION, Level = 10, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_3 ] = { Group = HEALBOT_REJUVENATION, Level = 16, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_4 ] = { Group = HEALBOT_REJUVENATION, Level = 22, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_5 ] = { Group = HEALBOT_REJUVENATION, Level = 28, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_6 ] = { Group = HEALBOT_REJUVENATION, Level = 34, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_7 ] = { Group = HEALBOT_REJUVENATION, Level = 40, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_8 ] = { Group = HEALBOT_REJUVENATION, Level = 46, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_9 ] = { Group = HEALBOT_REJUVENATION, Level = 52, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_10] = { Group = HEALBOT_REJUVENATION, Level = 58, Buff = HEALBOT_BUFF_REJUVENATION },
  [HEALBOT_REJUVENATION .. HEALBOT_RANK_11] = { Group = HEALBOT_REJUVENATION, Level = 60, Buff = HEALBOT_BUFF_REJUVENATION },

  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_1 ] = { Group = HEALBOT_HEALING_TOUCH, Level =  1 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_2 ] = { Group = HEALBOT_HEALING_TOUCH, Level =  8 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_3 ] = { Group = HEALBOT_HEALING_TOUCH, Level = 14 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_4 ] = { Group = HEALBOT_HEALING_TOUCH, Level = 20 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_5 ] = { Group = HEALBOT_HEALING_TOUCH, Level = 26 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_6 ] = { Group = HEALBOT_HEALING_TOUCH, Level = 32 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_7 ] = { Group = HEALBOT_HEALING_TOUCH, Level = 38 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_8 ] = { Group = HEALBOT_HEALING_TOUCH, Level = 44 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_9 ] = { Group = HEALBOT_HEALING_TOUCH, Level = 50 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_10] = { Group = HEALBOT_HEALING_TOUCH, Level = 56 },
  [HEALBOT_HEALING_TOUCH .. HEALBOT_RANK_11] = { Group = HEALBOT_HEALING_TOUCH, Level = 60 },

  [HEALBOT_REGROWTH .. HEALBOT_RANK_1] = { Group = HEALBOT_REGROWTH, Level = 12, Buff = HEALBOT_BUFF_REGROWTH },
  [HEALBOT_REGROWTH .. HEALBOT_RANK_2] = { Group = HEALBOT_REGROWTH, Level = 18, Buff = HEALBOT_BUFF_REGROWTH },
  [HEALBOT_REGROWTH .. HEALBOT_RANK_3] = { Group = HEALBOT_REGROWTH, Level = 24, Buff = HEALBOT_BUFF_REGROWTH },
  [HEALBOT_REGROWTH .. HEALBOT_RANK_4] = { Group = HEALBOT_REGROWTH, Level = 30, Buff = HEALBOT_BUFF_REGROWTH },
  [HEALBOT_REGROWTH .. HEALBOT_RANK_5] = { Group = HEALBOT_REGROWTH, Level = 36, Buff = HEALBOT_BUFF_REGROWTH },
  [HEALBOT_REGROWTH .. HEALBOT_RANK_6] = { Group = HEALBOT_REGROWTH, Level = 42, Buff = HEALBOT_BUFF_REGROWTH },
  [HEALBOT_REGROWTH .. HEALBOT_RANK_7] = { Group = HEALBOT_REGROWTH, Level = 48, Buff = HEALBOT_BUFF_REGROWTH },
  [HEALBOT_REGROWTH .. HEALBOT_RANK_8] = { Group = HEALBOT_REGROWTH, Level = 54, Buff = HEALBOT_BUFF_REGROWTH },
  [HEALBOT_REGROWTH .. HEALBOT_RANK_9] = { Group = HEALBOT_REGROWTH, Level = 60, Buff = HEALBOT_BUFF_REGROWTH },

-- HUNTER

  [HEALBOT_MEND_PET .. HEALBOT_RANK_1] = { Group = HEALBOT_MEND_PET, Target = {"pet"}, Level = 12 },
  [HEALBOT_MEND_PET .. HEALBOT_RANK_2] = { Group = HEALBOT_MEND_PET, Target = {"pet"}, Level = 20 },
  [HEALBOT_MEND_PET .. HEALBOT_RANK_3] = { Group = HEALBOT_MEND_PET, Target = {"pet"}, Level = 28 },
  [HEALBOT_MEND_PET .. HEALBOT_RANK_4] = { Group = HEALBOT_MEND_PET, Target = {"pet"}, Level = 36 },
  [HEALBOT_MEND_PET .. HEALBOT_RANK_5] = { Group = HEALBOT_MEND_PET, Target = {"pet"}, Level = 44 },
  [HEALBOT_MEND_PET .. HEALBOT_RANK_6] = { Group = HEALBOT_MEND_PET, Target = {"pet"}, Level = 52 },
  [HEALBOT_MEND_PET .. HEALBOT_RANK_7] = { Group = HEALBOT_MEND_PET, Target = {"pet"}, Level = 60 },

-- PRIEST

  [HEALBOT_LESSER_HEAL .. HEALBOT_RANK_1] = { Group = HEALBOT_LESSER_HEAL, Level =  1 }, 
  [HEALBOT_LESSER_HEAL .. HEALBOT_RANK_2] = { Group = HEALBOT_LESSER_HEAL, Level =  4 }, 
  [HEALBOT_LESSER_HEAL .. HEALBOT_RANK_3] = { Group = HEALBOT_LESSER_HEAL, Level = 10 }, 

  [HEALBOT_HEAL .. HEALBOT_RANK_1] = { Group = HEALBOT_HEAL, Level = 16 }, 
  [HEALBOT_HEAL .. HEALBOT_RANK_2] = { Group = HEALBOT_HEAL, Level = 22 }, 
  [HEALBOT_HEAL .. HEALBOT_RANK_3] = { Group = HEALBOT_HEAL, Level = 28 }, 
  [HEALBOT_HEAL .. HEALBOT_RANK_4] = { Group = HEALBOT_HEAL, Level = 34 }, 

  [HEALBOT_GREATER_HEAL .. HEALBOT_RANK_1] = { Group = HEALBOT_GREATER_HEAL, Level = 40 }, 
  [HEALBOT_GREATER_HEAL .. HEALBOT_RANK_2] = { Group = HEALBOT_GREATER_HEAL, Level = 46 }, 
  [HEALBOT_GREATER_HEAL .. HEALBOT_RANK_3] = { Group = HEALBOT_GREATER_HEAL, Level = 52 }, 
  [HEALBOT_GREATER_HEAL .. HEALBOT_RANK_4] = { Group = HEALBOT_GREATER_HEAL, Level = 58 }, 
  [HEALBOT_GREATER_HEAL .. HEALBOT_RANK_5] = { Group = HEALBOT_GREATER_HEAL, Level = 60 }, 

  [HEALBOT_RENEW .. HEALBOT_RANK_1] = { Group = HEALBOT_RENEW, Level =  8, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_2] = { Group = HEALBOT_RENEW, Level = 14, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_3] = { Group = HEALBOT_RENEW, Level = 20, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_4] = { Group = HEALBOT_RENEW, Level = 26, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_5] = { Group = HEALBOT_RENEW, Level = 32, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_6] = { Group = HEALBOT_RENEW, Level = 38, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_7] = { Group = HEALBOT_RENEW, Level = 44, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_8] = { Group = HEALBOT_RENEW, Level = 50, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_9] = { Group = HEALBOT_RENEW, Level = 56, Buff = HEALBOT_BUFF_RENEW }, 
  [HEALBOT_RENEW .. HEALBOT_RANK_10] = { Group = HEALBOT_RENEW, Level = 60, Buff = HEALBOT_BUFF_RENEW },

  [HEALBOT_FLASH_HEAL .. HEALBOT_RANK_1] = { Group = HEALBOT_FLASH_HEAL, Level = 20 }, 
  [HEALBOT_FLASH_HEAL .. HEALBOT_RANK_2] = { Group = HEALBOT_FLASH_HEAL, Level = 26 }, 
  [HEALBOT_FLASH_HEAL .. HEALBOT_RANK_3] = { Group = HEALBOT_FLASH_HEAL, Level = 32 }, 
  [HEALBOT_FLASH_HEAL .. HEALBOT_RANK_4] = { Group = HEALBOT_FLASH_HEAL, Level = 38 }, 
  [HEALBOT_FLASH_HEAL .. HEALBOT_RANK_5] = { Group = HEALBOT_FLASH_HEAL, Level = 44 }, 
  [HEALBOT_FLASH_HEAL .. HEALBOT_RANK_6] = { Group = HEALBOT_FLASH_HEAL, Level = 50 }, 
  [HEALBOT_FLASH_HEAL .. HEALBOT_RANK_7] = { Group = HEALBOT_FLASH_HEAL, Level = 56 }, 
	  
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_1] = { Group = HEALBOT_POWER_WORD_SHIELD, Level =  6, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_2] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 12, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_3] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 18, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_4] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 24, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_5] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 30, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_6] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 36, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_7] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 42, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_8] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 48, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_9] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 54, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 
  [HEALBOT_POWER_WORD_SHIELD .. HEALBOT_RANK_10] = { Group = HEALBOT_POWER_WORD_SHIELD, Level = 60, Buff= HEALBOT_BUFF_POWER_WORD_SHIELD, Debuff = HEALBOT_DEBUF_WEAKENED_SOUL }, 

-- SHAMAN

  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_1] = { Group = HEALBOT_HEALING_WAVE, Level =  1 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_2] = { Group = HEALBOT_HEALING_WAVE, Level =  6 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_3] = { Group = HEALBOT_HEALING_WAVE, Level = 12 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_4] = { Group = HEALBOT_HEALING_WAVE, Level = 18 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_5] = { Group = HEALBOT_HEALING_WAVE, Level = 24 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_6] = { Group = HEALBOT_HEALING_WAVE, Level = 32 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_7] = { Group = HEALBOT_HEALING_WAVE, Level = 40 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_8] = { Group = HEALBOT_HEALING_WAVE, Level = 48 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_9] = { Group = HEALBOT_HEALING_WAVE, Level = 56 }, 
  [HEALBOT_HEALING_WAVE .. HEALBOT_RANK_10] = { Group = HEALBOT_HEALING_WAVE, Level = 60 }, 

  [HEALBOT_LESSER_HEALING_WAVE .. HEALBOT_RANK_1] = { Group = HEALBOT_LESSER_HEALING_WAVE, Level = 20 }, 
  [HEALBOT_LESSER_HEALING_WAVE .. HEALBOT_RANK_2] = { Group = HEALBOT_LESSER_HEALING_WAVE, Level = 28 }, 
  [HEALBOT_LESSER_HEALING_WAVE .. HEALBOT_RANK_3] = { Group = HEALBOT_LESSER_HEALING_WAVE, Level = 36 }, 
  [HEALBOT_LESSER_HEALING_WAVE .. HEALBOT_RANK_4] = { Group = HEALBOT_LESSER_HEALING_WAVE, Level = 44 }, 
  [HEALBOT_LESSER_HEALING_WAVE .. HEALBOT_RANK_5] = { Group = HEALBOT_LESSER_HEALING_WAVE, Level = 52 }, 
  [HEALBOT_LESSER_HEALING_WAVE .. HEALBOT_RANK_6] = { Group = HEALBOT_LESSER_HEALING_WAVE, Level = 60 }, 

};

HealBot_Heals = {};

HealBot_CurrentSpells = {};
